class VariationalGNN(Module):
  __parameters__ = []
  __buffers__ = []
  training : bool
  _is_full_backward_hook : Optional[bool]
  embed : __torch__.torch.nn.modules.sparse.Embedding
  in_att : __torch__.torch.nn.modules.container.___torch_mangle_13.ModuleList
  out_att : __torch__.model.___torch_mangle_24.GraphLayer
  dropout : __torch__.torch.nn.modules.dropout.___torch_mangle_25.Dropout
  parameterize : __torch__.torch.nn.modules.linear.___torch_mangle_26.Linear
  out_layer : __torch__.torch.nn.modules.container.___torch_mangle_31.Sequential
  def forward(self: __torch__.model.VariationalGNN,
    data: Tensor) -> Tuple[Tensor, Tensor]:
    out_layer = self.out_layer
    out_att = self.out_att
    dropout = self.dropout
    parameterize = self.parameterize
    in_att = self.in_att
    _1 = getattr(in_att, "1")
    in_att0 = self.in_att
    _0 = getattr(in_att0, "0")
    embed = self.embed
    data0 = torch.slice(torch.select(data, 0, 0), 0, 0, 9223372036854775807)
    nonzero = torch.nonzero(data0)
    nonzero0 = torch.add(torch.transpose(nonzero, 0, 1), CONSTANTS.c0)
    lengths = ops.prim.NumToTensor(torch.size(nonzero0, 1))
    _2 = int(lengths)
    _3 = torch.repeat(nonzero0, [1, int(lengths)])
    _4 = torch.transpose(torch.repeat(nonzero0, [_2, 1]), 0, 1)
    _5 = torch.view(torch.contiguous(_4), [1, int(torch.pow(lengths, 2))])
    input_edges = torch.cat([_3, _5])
    _6 = torch.to(CONSTANTS.c1, torch.device("cpu"), 4)
    _7 = torch.to(_6, dtype=4, layout=0, device=torch.device("cuda"))
    nonzero1 = torch.cat([nonzero0, _7], 1)
    lengths0 = ops.prim.NumToTensor(torch.size(nonzero1, 1))
    _8 = int(lengths0)
    _9 = torch.repeat(nonzero1, [1, int(lengths0)])
    _10 = torch.transpose(torch.repeat(nonzero1, [_8, 1]), 0, 1)
    _11 = torch.view(torch.contiguous(_10), [1, int(torch.pow(lengths0, 2))])
    output_edges = torch.cat([_9, _11])
    edge = torch.to(input_edges, dtype=4, layout=0, device=torch.device("cuda"))
    edge0 = torch.to(output_edges, dtype=4, layout=0, device=torch.device("cuda"))
    _12 = torch.arange(10593, dtype=None, layout=None, device=torch.device("cpu"), pin_memory=False)
    input = torch.to(torch.to(_12, 4), dtype=4, layout=0, device=torch.device("cuda"))
    _13 = (_0).forward((embed).forward(input, ), edge, )
    _14, _15, = _13
    _16, _17, = (_1).forward(_14, _15, )
    input0 = torch.view((parameterize).forward(_16, ), [-1, 2, 768])
    _18 = (dropout).forward(input0, )
    _19 = torch.slice(_18, 0, 0, 9223372036854775807)
    h_prime = torch.slice(torch.select(_19, 1, 0), 1, 0, 9223372036854775807)
    _20 = torch.slice(_18, 0, 0, 9223372036854775807)
    logvar = torch.slice(torch.select(_20, 1, 1), 1, 0, 9223372036854775807)
    pat_diag_code_idx = torch.slice(torch.select(_17, 0, 0), 0, 0, 95)
    _21 = torch.slice(h_prime, 1, 0, 9223372036854775807)
    _22 = annotate(List[Optional[Tensor]], [pat_diag_code_idx])
    mu = torch.index(_21, _22)
    _23 = torch.slice(logvar, 1, 0, 9223372036854775807)
    _24 = annotate(List[Optional[Tensor]], [pat_diag_code_idx])
    logvar0 = torch.index(_23, _24)
    _25 = torch.select((out_att).forward(h_prime, edge0, ), 0, -1)
    _26 = torch.sub(torch.exp(logvar0), logvar0)
    _27 = torch.add(torch.sub(_26, CONSTANTS.c0), torch.pow(mu, 2))
    _28 = torch.mul(torch.sum(_27), CONSTANTS.c2)
    _29 = ops.prim.NumToTensor(torch.size(mu, 0))
    _30 = torch.div(_28, _29)
    input1 = torch.stack([_25])
    input2 = torch.relu(input1)
    _31 = ((out_layer).forward(input2, ), torch.sum(torch.stack([_30])))
    return _31
class GraphLayer(Module):
  __parameters__ = []
  __buffers__ = []
  training : bool
  _is_full_backward_hook : Optional[bool]
  W : __torch__.torch.nn.modules.container.ModuleList
  a : __torch__.torch.nn.modules.container.ParameterList
  ffn : __torch__.torch.nn.modules.container.Sequential
  V : __torch__.torch.nn.modules.linear.___torch_mangle_1.Linear
  dropout : __torch__.torch.nn.modules.dropout.Dropout
  leakyrelu : __torch__.torch.nn.modules.activation.LeakyReLU
  norm : __torch__.model.LayerNorm
  def forward(self: __torch__.model.GraphLayer,
    argument_1: Tensor,
    edge: Tensor) -> Tuple[Tensor, Tensor]:
    norm = self.norm
    dropout = self.dropout
    leakyrelu = self.leakyrelu
    a = self.a
    _0 = getattr(a, "0")
    W = self.W
    _032 = getattr(W, "0")
    data = torch.unsqueeze((_032).forward(argument_1, ), 0)
    _30 = torch.slice(torch.select(edge, 0, 0), 0, 0, 9223372036854775807)
    _31 = torch.slice(data, 0, 0, 9223372036854775807)
    _32 = torch.slice(_31, 2, 0, 9223372036854775807)
    _33 = annotate(List[Optional[Tensor]], [None, _30])
    _34 = torch.index(_32, _33)
    _35 = torch.slice(torch.select(edge, 0, 1), 0, 0, 9223372036854775807)
    _36 = torch.slice(data, 0, 0, 9223372036854775807)
    _37 = torch.slice(_36, 2, 0, 9223372036854775807)
    _38 = annotate(List[Optional[Tensor]], [None, _35])
    h = torch.cat([_34, torch.index(_37, _38)])
    data1 = torch.squeeze(data, 0)
    _39 = torch.slice(torch.select(h, 0, 0), 0, 0, 9223372036854775807)
    _40 = torch.slice(_39, 1, 0, 9223372036854775807)
    _41 = torch.slice(torch.select(h, 0, 1), 0, 0, 9223372036854775807)
    _42 = torch.slice(_41, 1, 0, 9223372036854775807)
    edge_h = torch.transpose(torch.cat([_40, _42], 1), 0, 1)
    input = torch.squeeze(torch.mm(_0, edge_h))
    _43 = torch.div((leakyrelu).forward(input, ), CONSTANTS.c3)
    edge_e = torch.exp(_43)
    edge_e0 = torch.to(edge_e, torch.device("cuda:0"), 6)
    edge1 = torch.to(edge, torch.device("cuda:0"), 4)
    edge_e1 = torch.sparse_coo_tensor(edge1, edge_e0, [10593, 10593], dtype=6, layout=1, device=torch.device("cuda:0"))
    _44 = torch.ones([10593, 1], dtype=None, layout=None, device=torch.device("cpu"), pin_memory=False)
    _45 = torch.to(_44, dtype=6, layout=0, device=torch.device("cuda"))
    e_rowsum = torch._sparse_mm(edge_e1, _45)
    row_check = torch.eq(e_rowsum, 0)
    _46 = annotate(List[Optional[Tensor]], [row_check])
    e_rowsum0 = torch.index_put_(e_rowsum, _46, CONSTANTS.c4)
    _47 = torch.slice(torch.nonzero(row_check), 0, 0, 9223372036854775807)
    zero_idx = torch.select(_47, 1, 0)
    _48 = torch.repeat(zero_idx, [2, 1])
    _49 = torch.ones([10498], dtype=None, layout=None, device=torch.device("cpu"), pin_memory=False)
    _50 = torch.to(_49, dtype=6, layout=0, device=torch.device("cuda"))
    _51 = torch.sparse_coo_tensor(_48, _50, [10593, 10593])
    edge_e2 = torch.add(edge_e1, _51)
    h_prime = torch._sparse_mm(edge_e2, data1)
    h_prime0 = torch.div_(h_prime, e_rowsum0)
    input3 = torch.cat([h_prime0], 1)
    _52 = (norm).forward((dropout).forward(input3, ), )
    input4 = torch.elu(_52, 1.)
    return (input4, edge1)
class LayerNorm(Module):
  __parameters__ = ["a_2", "b_2", ]
  __buffers__ = []
  a_2 : Tensor
  b_2 : Tensor
  training : bool
  _is_full_backward_hook : Optional[bool]
  def forward(self: __torch__.model.LayerNorm,
    argument_1: Tensor) -> Tensor:
    b_2 = self.b_2
    a_2 = self.a_2
    mean = torch.mean(argument_1, [-1], True)
    std = torch.std(argument_1, [-1], True, True)
    _53 = torch.mul(a_2, torch.sub(argument_1, mean))
    _54 = torch.div(_53, torch.add(std, CONSTANTS.c5))
    return torch.add(_54, b_2)
