class GraphLayer(Module):
  __parameters__ = []
  __buffers__ = []
  training : bool
  _is_full_backward_hook : Optional[bool]
  W : __torch__.torch.nn.modules.container.___torch_mangle_15.ModuleList
  a : __torch__.torch.nn.modules.container.___torch_mangle_16.ParameterList
  ffn : __torch__.torch.nn.modules.container.___torch_mangle_19.Sequential
  V : __torch__.torch.nn.modules.linear.___torch_mangle_20.Linear
  dropout : __torch__.torch.nn.modules.dropout.___torch_mangle_21.Dropout
  leakyrelu : __torch__.torch.nn.modules.activation.___torch_mangle_22.LeakyReLU
  norm : __torch__.model.___torch_mangle_23.LayerNorm
  def forward(self: __torch__.model.___torch_mangle_24.GraphLayer,
    h_prime: Tensor,
    edge: Tensor) -> Tensor:
    V = self.V
    norm = self.norm
    dropout = self.dropout
    leakyrelu = self.leakyrelu
    a = self.a
    _0 = getattr(a, "0")
    W = self.W
    _00 = getattr(W, "0")
    data = torch.unsqueeze((_00).forward(h_prime, ), 0)
    _1 = torch.slice(torch.select(edge, 0, 0), 0, 0, 9223372036854775807)
    _2 = torch.slice(data, 0, 0, 9223372036854775807)
    _3 = torch.slice(_2, 2, 0, 9223372036854775807)
    _4 = annotate(List[Optional[Tensor]], [None, _1])
    _5 = torch.index(_3, _4)
    _6 = torch.slice(torch.select(edge, 0, 1), 0, 0, 9223372036854775807)
    _7 = torch.slice(data, 0, 0, 9223372036854775807)
    _8 = torch.slice(_7, 2, 0, 9223372036854775807)
    _9 = annotate(List[Optional[Tensor]], [None, _6])
    h = torch.cat([_5, torch.index(_8, _9)])
    data0 = torch.squeeze(data, 0)
    _10 = torch.slice(torch.select(h, 0, 0), 0, 0, 9223372036854775807)
    _11 = torch.slice(_10, 1, 0, 9223372036854775807)
    _12 = torch.slice(torch.select(h, 0, 1), 0, 0, 9223372036854775807)
    _13 = torch.slice(_12, 1, 0, 9223372036854775807)
    edge_h = torch.transpose(torch.cat([_11, _13], 1), 0, 1)
    input = torch.squeeze(torch.mm(_0, edge_h))
    _14 = torch.div((leakyrelu).forward(input, ), CONSTANTS.c3)
    edge_e = torch.exp(_14)
    edge_e0 = torch.to(edge_e, torch.device("cuda:0"), 6)
    edge0 = torch.to(edge, torch.device("cuda:0"), 4)
    edge_e1 = torch.sparse_coo_tensor(edge0, edge_e0, [10593, 10593], dtype=6, layout=1, device=torch.device("cuda:0"))
    _15 = torch.ones([10593, 1], dtype=None, layout=None, device=torch.device("cpu"), pin_memory=False)
    _16 = torch.to(_15, dtype=6, layout=0, device=torch.device("cuda"))
    e_rowsum = torch._sparse_mm(edge_e1, _16)
    row_check = torch.eq(e_rowsum, 0)
    _17 = annotate(List[Optional[Tensor]], [row_check])
    e_rowsum0 = torch.index_put_(e_rowsum, _17, CONSTANTS.c4)
    _18 = torch.slice(torch.nonzero(row_check), 0, 0, 9223372036854775807)
    zero_idx = torch.select(_18, 1, 0)
    _19 = torch.repeat(zero_idx, [2, 1])
    _20 = torch.ones([10497], dtype=None, layout=None, device=torch.device("cpu"), pin_memory=False)
    _21 = torch.to(_20, dtype=6, layout=0, device=torch.device("cuda"))
    _22 = torch.sparse_coo_tensor(_19, _21, [10593, 10593])
    edge_e2 = torch.add(edge_e1, _22)
    h_prime0 = torch._sparse_mm(edge_e2, data0)
    h_prime1 = torch.div_(h_prime0, e_rowsum0)
    input0 = torch.mean(torch.stack([h_prime1]), [0])
    _23 = (norm).forward((dropout).forward(input0, ), )
    input1 = torch.relu(_23)
    return (V).forward(input1, )
